UNIT DEBUGGER;
{$r-,q-,i-,x+,opt+,d-,l-}
{
This is the debugger unit.
-----------------------------------------
Current Version:
         0.01 - 22-02-99 by JacmeT (jacmet@iname.com)

Purpose: 
         To be a general way to output
         debugging information from 
         programs / part of programs that
         cannot easily just be printet to the
         screen (this can be because the
         program switches to a gfx. mode, 
         something timecritical is happening
         (like interrupts) and so on).
         At this time the standard writeln(file,text)
         is used because of the ease of use.

         
Functionality:
         + Selection of output filename with commandline parameter
         + automatic initialization/deinitialization

         (minus indicates not done yet, 
         plus indicates it is implemented and tested
         and question mark indicates implemented
         (perhaps partly) but not tested yet)

History:
         22-02-99: First revision (0.01)
         --------------------------------
         This is the very first version.
         Not much is working at the moment
         - But it'll come!   
}

INTERFACE

 uses TOOL;

 const FILENAME = 'debug.out';

 var FileHandle: text;
     OldExitProcedure: pointer;

IMPLEMENTATION

Procedure Init;
 begin
  {check for commandline parameter}
  if ParamCount>0 then
   begin
    assign(DEBUGGER.FileHandle,ParamStr(1));
    rewrite(DEBUGGER.FileHandle);
   end
  else
   begin
    assign(DEBUGGER.FileHandle,DEBUGGER.FILENAME);
    rewrite(DEBUGGER.FileHandle);
   end;    
 end;

Procedure DeInit;
 begin
  {restore exitprocedure}
  exitproc:=OldExitprocedure;
  close(DEBUGGER.FileHandle); 
end;

 begin
  DEBUGGER.Init;
  {install exitprocedure}
  OldExitprocedure:=exitproc;
  exitproc:=@DEBUGGER.DeInit;
 end.