program bumpmap;
uses gfx,crt;

type bumptype = record
                 X,Y: byte;
                end;
        mType = record
                 X,Y: byte;
                end;

{{$DEFINE USEPASSWORD}

{$IFDEF USEPASSWORD}
 const password : array[1..4] of char = '9601';
{$ENDIF}

var
    picture1   : array[0..199,0..319] of byte;          {our picture - that is indexes into the pallette}
    picture2   : array[0..63999] of byte absolute picture1; 
    Pallette   : array[0..255] of GFX.PixelType;        {the pallette of the picture}
    screen1    : array[0..199,0..319] of GFX.PixelType; {our screen buffer}
    screen2    : array[0..63999] of GFX.PixelType absolute Screen1;
    ShadeTable1: array[0..255,0..255] of GFX.PixelType; {the 256 different shades for every color}
    ShadeTable2: array[0..65335] of GFX.PixelType absolute ShadeTable1;   
    LightTable1: array[0..255,0..255] of byte;          {the lightsource} 
    LightTable2: array[0..65535] of byte absolute LightTable1;
    BumpTable1 : array[0..199,0..319] of bumptype;         {the bump map (displacement table)}
    BumpTable2 : array[0..63999] of bumptype absolute BumpTable1;

    displace1 : array[0..199,0..319] of word;
    displace2 : array[0..63999] of word absolute displace1;

    movement  : array[0..255] of mType;
    movement2 : array[0..255] of word absolute movement;

Procedure ReadPCXfile(Filename: string); 
Type PalT = Record
              R,G,B: byte;
             end;
 var  f: file;
      Pal:^array[0..255] of PalT;
      b: byte;
      p: ^array[0..100000] of byte;
      l,m: dword;
 begin
  assign(f,filename);
  reset(f,1);
  getmem(p,filesize(f));
  Blockread(f,p^,filesize(f));

  m:=0;
  l:=128;
 repeat
  if ((p^[l] and 192)=192) then
   begin
    for b:=1 to (p^[l] and 63) do
     begin
      picture2[m]:=p^[l+1];
      m:=m+1;
     end;
    l:=l+2;
   end
  else
   begin
    picture2[m]:=p^[l];
    m:=m+1;
    l:=l+1;
   end;
  until m>63999;

  pal:=pointer(dword(@p^[l])+1);
  for b:=0 to 255 do 
   begin
    pallette[b].r:=pal^[b].r;
    pallette[b].g:=pal^[b].g;
    pallette[b].b:=pal^[b].b;
   end;
  freemem(p,filesize(f));
  close(f);
 end;

procedure SetupShadeTableA;
 var color,intensity,r,g,b,temp: dword;
 begin
  for color:=0 to 255 do
   begin
    for intensity:=0 to 255 do
     begin
      temp:=(Pallette[color].R*Intensity) shr 6;
      if temp>255 then temp:=255;
      ShadeTable1[color,intensity].R:=temp;
      temp:=(Pallette[color].G*Intensity) shr 6;
      if temp>255 then temp:=255;
      ShadeTable1[color,intensity].G:=temp;
      temp:=(Pallette[color].B*Intensity) shr 6;
      if temp>255 then temp:=255;
      ShadeTable1[color,intensity].B:=temp;
     end;
   end;
 end;

procedure SetupShadeTableB;
 var color,intensity,r,g,b,temp: longint;
 begin
  for color:=0 to 255 do
   begin
    for intensity:=0 to 255 do
     begin
      temp:=Pallette[color].R+intensity*2-170;
      if temp>255 then temp:=255; if temp<0 then temp:=0;
      ShadeTable1[color,intensity].R:=temp;
      temp:=Pallette[color].G+intensity*2-170;
      if temp>255 then temp:=255; if temp<0 then temp:=0;
      ShadeTable1[color,intensity].G:=temp;
      temp:=Pallette[color].B+intensity*2-170;
      if temp>255 then temp:=255; if temp<0 then temp:=0;
      ShadeTable1[color,intensity].B:=temp;
     end;
   end;
 end;

Procedure SetupLightTable;
 const size=4.5;
 var a,b,c: dword;
 begin
  for a:=0 to 255 do
   begin
    for b:=0 to 255 do
     begin
      if round(sqrt(sqr(a-128.0)+sqr(b-128.0))*size)>255 then c:=255 else c:=round(sqrt(sqr(a-128.0)+sqr(b-128.0))*size);
      LightTable1[a,b]:=255-c;
     end;
   end;
 end;

Procedure SetupBumpTable;
  var a,b: longint;
  begin
   for a:=1 to 198 do
    begin
     BumpTable1[a,0].x:=0; BumpTable1[a,0].y:=0;
     for b:=1 to 318 do
      begin
       BumpTable1[a,b].x:=((picture1[a+1,b]-picture1[a-1,b]) shr 3)+64;
       BumpTable1[a,b].y:=((picture1[a,b+1]-picture1[a,b-1]) shr 3)+64;
      end;
     BumpTable1[a,319].x:=BumpTable1[a,318].x; BumpTable1[a,319].y:=BumpTable1[a,318].y;
     BumpTable1[a,0].x:=BumpTable1[a,1].x; BumpTable1[a,0].y:=BumpTable1[a,1].y;
    end;
    for b:=0 to 319 do begin BumpTable1[199,b].x:=BumpTable1[198,b].x; BumpTable1[199,b].y:=BumpTable1[198,b].y; end;
    for b:=0 to 319 do begin BumpTable1[0,b].x:=BumpTable1[1,b].x; BumpTable1[0,b].y:=BumpTable1[1,b].y; end;
 end;

procedure main;
var d,v: longint;
     x,y: dword;
     {$IFDEF USEPASSWORD}
      passpos: dword;
      passchar: char;
     {$ENDIF}
 begin
  {$IFDEF USEPASSWORD}
   passpos:=1;
  {$ENDIF}

  SetupShadeTableB;
  SetupLightTable;
  SetupBumpTable;


  for v:=0 to 255 do
   begin
    movement[v].X:=80+round(sin(v*pi/32)*40);
    movement[v].Y:=50+round(cos(v*pi/64)*60);
   end;

  for y:=0 to 199 do
    begin
    for x:=0 to 319 do
     begin
      displace1[y,x]:=(((y shr 1)+bumpTable1[y,x].Y-64) and 255)+((((x shr 1) +bumpTable1[y,x].X-64) and 255) shl 8) and $FFFF;
     end;
    end;

 repeat
  for y:=0 to 63999 do
   begin
    d:=LightTable2[(Displace2[Y]+Movement2[(v+00) and 255]) and $FFFF]+LightTable2[(Displace2[Y]+Movement2[(v+32) and 255]) and $FFFF];
    if d>255 then d:=255;
    Screen2[y].color:=ShadeTable1[Picture2[y],d].color;    
   end;
  
   GFX.FLIPPAGE(@Screen2);

   v:=(v+1) and 255;
 
 {$IFDEF USEPASSWORD}
  if keypressed then
   begin
    passchar:=readkey;
    if passchar=password[passpos] then inc(passpos) else passpos:=1;
   end;
  until passpos=5;
 {$ELSE}
  until keypressed;
 {$ENDIF}
end;

begin
 ReadPCXfile('gfx.pcx');
 GFX.Setmode(320,200); 
 main;
end.